<?php

class OUnit extends Unit {

	function OUnit(){
		parent::Unit();
		$this->dn_list['title'] = 3;
		$this->dn_list['ans_no'] = 4;
		$this->dn_list['agree'] = 11;
		$this->dn_list['neutral'] = 12;
		$this->dn_list['opposite'] = 13;
	}

	//data----------------------------------------------
	function init_data($name,$pass,$pid,$title){
		parent::init_data($name,$pass,$pid);
		$this->data[3] = $title;    //title
		$this->data[4] = "0";     //solution
		$this->data[10] = '';     //ansp
		$this->data[11] = 0;      //^
		$this->data[12] = 0;      //ǂłȂ
		$this->data[13] = 0;      //
	}

	function increase_ans_no(){ ++$this->data[4]; }
	function decrease_ans_no(){ --$this->data[4]; }

	function increase_agree(){ ++$this->data[11]; }
	function increase_neutral(){ ++$this->data[12]; }
	function increase_opposite(){ ++$this->data[13]; }
	function decrease_agree(){ --$this->data[11]; }
	function decrease_neutral(){ --$this->data[12]; }
	function decrease_opposite(){ --$this->data[13]; }

	//body--------------------------------------------
	function get_log_body() {
		$body = parent::get_body();
		$body.= "<op>\n";
		return $body;
	}

	//Unit----------------------------------------------
	function get_unit(){
		$qunit = $this->get_log_data();
		$qunit.= $this->get_log_body();
		return $qunit;
	}

	function get_show_unit(){
		$q_data = $this->get_data_array();
		$q_body = $this->get_body();
		return array($q_data,$q_body);
	}
}

class AUnit extends Unit {

	function AUnit(){
		parent::Unit();
		$this->dn_list['delete'] = 4;
		$this->dn_list['vote'] = 10;
	}

	//data----------------------------------------------
	function init_data($name,$pass,$pid,$vote){
		parent::init_data($name,$pass,$pid);
		$this->data[4] = "no";     //delete
		$this->data[10] = $vote;   //[
	}

	function set_delete() { $this->data[4] = "ok"; }
	function reset_vote() { $this->data[10] = 0; }

	//body--------------------------------------------
	function get_log_body() {
		$abody = parent::get_body();
		$abody.= "<ans>\n";
		return $abody;
	}

	//Unit----------------------------------------------
	function get_unit(){
		$aunit = $this->get_log_data();
		$aunit.= $this->get_log_body();
		return $aunit;
	}

	function get_show_unit(){
		$a_data = $this->get_data_array();
		$a_body = $this->get_body();
		return array($a_data,$a_body);
	}
}

class OpinionLog extends Log {
	var $list; //UNITw|C^̃Xg

	function OpinionLog(){
		$this->list = array();
		parent::Log();
	}

	function set_last($no) { $this->last = $no; }
	function set_null($no) { $this->list[$no] = NULL; }

	function set_log ($log) {
		//҃f[^
		$optioner_data = array_shift($log);
		$this->top = & new OUnit();
		$this->top->set_data($optioner_data);

		//e
		while (list($key,$value) = each($log)){
			if (preg_match('/^<op>/', $value)) break;
			else $this->top->add_body($value);
		}
		$this->list[0] = & $this->top;

		//Ԏf[^
		$i = 1;
		while (list($key,$value) = each($log)){ //EOF܂Ŏs
			$new_aunit = & new AUnit();
			$new_aunit->set_data($value);
			while (list($bkey,$bvalue) = each($log)){
				if (preg_match('/^<ans>/', $bvalue)) break;
				else $new_aunit->add_body($bvalue);
			}
			$this->list[$i]= & $new_aunit;
			++$i;
		}
		$this->set_last($i);
	}

	function new_aunit ($name,$pass,$pid,$body,$vote,$url,$tcl,$bcl,$icon,$type,$fname) {
		$aunit = & new AUnit();
		$aunit->init_data($name,$pass,$pid,$vote);
		$aunit->init_odata($url,$tcl,$bcl,$icon,$type,$fname);
		$aunit->set_body($body);
		$this->list[$this->last] = & $aunit;
		$this->set_last($this->last + 1);
	}

	function del_last_aunit ($no) {
		$vno = $this->list[$no]->get_data("vote");
		if ($vno == 1) $this->top->decrease_agree();
		else if ($vno == 2) $this->top->decrease_neutral();
		else if ($vno == 3) $this->top->decrease_opposite();

		$this->set_last($no - 1);
		$this->set_null($no);
	}

	function set_delete($no,$admin) {
		$aunit = & new AUnit();
		$aunit->set_data($this->list[$no]->get_log_data());
		$aunit->set_delete();

		$vno = $aunit->get_data("vote");
		if ($vno == 1) $this->top->decrease_agree();
		else if ($vno == 2) $this->top->decrease_neutral();
		else if ($vno == 3) $this->top->decrease_opposite();
		$aunit->reset_vote();

		$del_time = date("yNmdG:i:s",time());
		if($admin){ //Ǘlɂ폜\
			$body = "̕Ԏe(" .$del_time .")ɊǗl폜܂B";
		} else { //e҂ɂ폜\
			$body = "̕Ԏe(" .$del_time .")ɍ폜܂B";
		}
		$aunit->add_body($body);
		$this->list[$no] = & $aunit;
	}

	// ### Unitf[^

	// OUnit
	function increase_ans_no() { $this->top->increase_ans_no(); }
	function decrease_ans_no() { $this->top->decrease_ans_no(); }

	function increase_agree() { $this->top->increase_agree(); }
	function increase_neutral() { $this->top->increase_neutral(); }
	function increase_opposite() { $this->top->increase_opposite(); }

	// data
	function get_data($no,$name) { return $this->list[$no]->get_data($name); }
	function get_data_array($no) { return $this->list[$no]->get_data_array(); }
	function get_odata($no,$name) { return $this->list[$no]->get_odata($name); }
	function get_odata_array($no) { return $this->list[$no]->get_odata_array(); }
	function get_body($no) { return $this->list[$no]->get_body(); }

	function get_unit($no) { return $this->list[$no]->get_unit(); }
	function get_show_unit($no) { return $this->list[$no]->get_show_unit(); }

	//Log
	function get_log (){
		$i = 0;
		while ($this->list[$i] != NULL){
			$log.= $this->list[$i]->get_unit();
			++$i;
		}
		return $log;
	}
}

?>